import javafx.scene.Group;
import javafx.scene.image.Image;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.transform.Rotate;

/**
 * GfBO
 */
public class PRSpriteEnding extends PRSprite implements PRConstant {

	/** XvCg` */
	private static final String	ENDING_CONGRATULATIONS	= "PRSpriteEnding_Congratulations";
	private static final String ENDING_THEEND			= "PRSpriteEnding_TheEnd";

	private static float[]		POINTS_2		= {
		-48.0f, -360.0f, 0,
		-48.0f,  360.0f, 0,
		 48.0f,  360.0f, 0,
		 48.0f, -360.0f, 0
	};

	private static float[]		TEXCOORDS  		 = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static int[]		FACES			= {
		0, 0, 1, 1, 2, 2,
		2, 2, 3, 3, 0, 0
	};

	/** C[W */
	private static Image		image			= null;

	/** O[v */
	private		Group			group			= null;

	/** bVr[ */
	private		MeshView		meshView		= null;

	/**  */
	private 	int				time			= 0;

	/**
	 * 
	 */
	public static void init() {

		try{

			ObjReader.init(ENDING_CONGRATULATIONS , "3d/Congratulations.obj");
			ObjReader.init(ENDING_THEEND, "3d/TheEnd.obj");

			PRSpriteEnding.image = PRImage.getImage("3d/image_Ending01.png");

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteEnding(PRApplication application){

		super(application);

	} // end PRSpriteEnding

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		time++;

		// ͂߂̎
		if(time == 1){

			// ݒ
			application.initLight0();

			// XvCg𐶐
			group = new Group();

			// O[vo^
			this.getChildren().add(group);

			// IuWFNg
			ObjReader.create(group, ENDING_CONGRATULATIONS);

			// ړ
			group.setTranslateY(-1.0);

		// 6b
		}else if(time < 360){

			// ړ
			group.setTranslateZ(time / 360.0 * 15);

		// 12b
		}else if(time < 720){

			// Ȃ

		// 19b
		}else if(time < 1160){

			// ړ
			group.setTranslateZ(15 + (time - 720.0) / (1160 - 720) * 300);

			// 12b
			if(time == 720){

				// t@t@[BGMtF[hAEg
				application.fadeoutMP3BGMFanfare();

			}

		// 19b
		}else if(time == 1160){

			// O[v폜
			this.getChildren().remove(group);

			// ݒ
			application.initLight();

			// GfBOBGMX^[g
			application.startMP3BGMEnding();

			// bVr[𐶐
			meshView = new MeshView();

			// bV𐶐
			TriangleMesh mesh = new TriangleMesh();

			mesh.getPoints().addAll(POINTS_2);
			mesh.getTexCoords().addAll(TEXCOORDS);
			mesh.getFaces().addAll(FACES);

			// }eA𐶐
			PhongMaterial material = new PhongMaterial();
			material.setDiffuseMap(image);

			// bVo^
			meshView.setMesh(mesh);
			meshView.setMaterial(material);

			// ]
			meshView.getTransforms().add(new Rotate(-72.0, Rotate.X_AXIS));

			// ʒuC
			meshView.setTranslateY(144.0);
			meshView.setTranslateZ(-233.0);

			// bVr[ǉ
			this.getChildren().add(meshView);

		// 69.5b
		}else if(time < 4170){

			// ړ
			meshView.setTranslateY(meshView.getTranslateY() - 0.3090 / 3.3);
			meshView.setTranslateZ(meshView.getTranslateZ() + 0.9511 / 3.3);

		// 70b
		}else if(time == 4200){

			// bV폜
			this.getChildren().remove(group);

			// ݒ
			application.initLight0();

			// XvCg𐶐
			group = new Group();

			// O[vo^
			this.getChildren().add(group);

			// IuWFNg
			ObjReader.create(group, ENDING_THEEND);

			// ړ
			group.setTranslateY(-1.0);

		// 73b
		}else if(time < 4380){

			// ړ
			group.setTranslateZ(6 + (4380.0 - time) / (4380.0 - 4200) * 300);

		// 83b
		}else if(time < 4980){

			// Ȃ

		// 88b
		}else if(time < 5280){

			// ړ
			group.setTranslateZ(6 + (time - 4980) / (5280.0 - 5160) * 300);

		// 90b
		}else if(time < 5400){

			// Ȃ

		// 90b
		}else if(time == 5400){

			// O[v폜
			this.getChildren().remove(group);

			// GfBO폜ig폜j
			this.remove();

			// ݒ
			application.initLight();

			// tF[Yݒ
			super.application.setPhase(PHASE_INIT);

		} // end if 

	} // end run

}
