import javafx.collections.ObservableList;
import javafx.geometry.Bounds;
import javafx.scene.Node;

/**
 * 
 */
public class PRSpritePole extends PRSpriteT {

	/** XvCg` */
	private static final String	POLE_WHITE		= "PRSpritePole_WHITE";
	private static final String	POLE_PURPLE		= "PRSpritePole_PURPLE";

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(POLE_WHITE, "3d/Pole_White.obj");
			ObjReader.init(POLE_PURPLE, "3d/Pole_Purple.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param strPattern zup^[
	 * @param stage Xe[W
	 */
	public PRSpritePole(PRApplication application, String strPattern){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			if("".equals(strPattern)){

				ObjReader.create(this, POLE_WHITE);

				// ʒuݒ
				double x = Math.random() * 24.0 - 12.0;
				super.setTranslateX(x);
				super.setTranslateY(0.00);
				super.setTranslateZ(150);

			}else if("".equals(strPattern)){

				ObjReader.create(this, POLE_PURPLE);

				// ʒuݒ
				double x = Math.random() * 24.0 - 12.0;
				super.setTranslateX(x);
				super.setTranslateY(0.00);
				super.setTranslateZ(150);

			}else if("".equals(strPattern)){

				ObjReader.create(this, POLE_PURPLE);

				// ʒuݒ
				super.setTranslateX(-5.0);
				super.setTranslateY(0.0);
				super.setTranslateZ(150);

			}else if("E".equals(strPattern)){

				ObjReader.create(this, POLE_PURPLE);

				// ʒuݒ
				super.setTranslateX(5.0);
				super.setTranslateY(0.0);
				super.setTranslateZ(150);

			}

			// xݒ
			mz = -1.0;

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpritePole

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		double x = super.getTranslateX();
		x = x + mx;

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0){
			// 폜
			super.remove();
		}

		// ړ
		super.setTranslateZ(z);

		//
		// 蔻
		//

		// E擾
		Bounds boundsThis = this.getBoundsInParent();

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = application.getNodeLst();

		// XvCgꗗ̌擾
		int countNodeLst = nodeLst.size();

		// XvCgꗗ̌A[v
		for(int i = 0; i < countNodeLst; i++){

			// XvCg擾
			Node node = nodeLst.get(i);

			// ȅꍇA
			if(node instanceof PRSpriteTama){

				// ĂꍇA
				if(boundsThis.intersects(node.getBoundsInParent())){

					// e֕ϊ
					PRSpriteTama spriteTama = (PRSpriteTama)node;

					// ˕ԂĂꍇA
					if(spriteTama.isRapel()){
						// ReBj[
						continue;
					}

					// e𒵂˕Ԃ
					spriteTama.rapel();

					// [v𔲂
					break;

				} // end if Ăꍇ

			} // end if ȅꍇ

		} // end for XvCgꗗ̌A[v

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.4;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.8;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.2;
	}

}
