import javafx.scene.image.Image;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.paint.Color;
import javafx.collections.ObservableList;
import javafx.scene.Node;

/**
 * 
 */
public class PRSpriteSky extends PRSprite {

	private static float[]		POINTS			= {
		-100.0f, -100, 0,
		-100.0f,  100, 0,
		 100.0f,  100, 0,
		 100.0f, -100, 0
	};

	private static float[]		TEXCOORDS  		 = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static int[]		FACES			= {
		0, 0, 1, 1, 2, 2,
		2, 2, 3, 3, 0, 0
	};

	private static float[]		POINTS_SKY1		= {
		-100.0f, -112, 0,
		-100.0f,  -32, 0,
		 100.0f,  -32, 0,
		 100.0f, -112, 0
	};

	private static float[]		POINTS_SKY2		= {
		-100.0f,  -30, 0,
		-100.0f,   00, 0,
		 100.0f,   00, 0,
		 100.0f,  -30, 0
	};

	/** C[W */
	private static Image[]		images			= null;

	/** }eA */
	private		PhongMaterial	material		= null;

	/** Pm[hꗗ */
	private		MeshView[]		meshViewSky1s	= null;

	/** Qm[hꗗ */
	private		MeshView[]		meshViewSky2s	= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			PRSpriteSky.images = new Image[]{
				PRImage.getImage("3d/imageStage1-1.png"),
				PRImage.getImage("3d/imageStage1-2.png"),
				PRImage.getImage("3d/imageStage2-1.png"),
				PRImage.getImage("3d/imageStage2-2.png"),
			};
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteSky(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// Yݒ
			super.setTranslateY(1.0);

			// bVr[𐶐
			MeshView meshView = new MeshView();

			// bV𐶐
			TriangleMesh mesh = new TriangleMesh();

			mesh.getPoints().addAll(POINTS);
			mesh.getTexCoords().addAll(TEXCOORDS);
			mesh.getFaces().addAll(FACES);

			// }eA𐶐
			material = new PhongMaterial();
			material.setDiffuseColor(Color.DARKTURQUOISE);

			// ʒuC
			meshView.setTranslateZ(300); 

			// bVo^
			meshView.setMesh(mesh);
			meshView.setMaterial(material);

			// bVr[ǉ
			this.getChildren().add(meshView);

			// Xe[WPŐݒ
			this.setStage(1);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteSky

	/**
	 * Xe[Wݒ
	 * @param stage Xe[W
	 */
	public void setStage(int stage){

		// m[hꗗ擾
		ObservableList<Node> nodeLst = this.getChildren();

		// m[hꗗ̌擾
		int countNodeLst = nodeLst.size();

		// m[hꗗm[h폜
		// Oij͊܂܂Ȃ
		nodeLst.remove(1, countNodeLst);

		// Xe[WP̏ꍇA
		if(stage == 1){

			// ̐F_[NE^[RCYF
			material.setDiffuseColor(Color.DARKTURQUOISE);

			// Pm[hꗗ𐶐
			meshViewSky1s = new MeshView[2];

			// QA[v
			for(int i = 0; i < 2; i++){

				// bVr[𐶐
				MeshView meshView = new MeshView();

				// bV𐶐
				TriangleMesh mesh = new TriangleMesh();

				mesh.getPoints().addAll(POINTS_SKY1);
				mesh.getTexCoords().addAll(TEXCOORDS);
				mesh.getFaces().addAll(FACES);

				// }eA𐶐
				PhongMaterial material = new PhongMaterial();
				material.setDiffuseMap(images[0]);

				// bVo^
				meshView.setMesh(mesh);
				meshView.setMaterial(material);

				// ʒuC
				meshView.setTranslateX(i * 200);
				meshView.setTranslateZ(299.9999); 

				// bVr[ǉ
				this.getChildren().add(meshView);

				// Pm[hꗗɐݒ
				meshViewSky1s[i] = meshView;

			} // end for PA[v

			// Qm[hꗗ𐶐
			meshViewSky2s = new MeshView[2];

			// QA[v
			for(int i = 0; i < 2; i++){

				// bVr[𐶐
				MeshView meshView = new MeshView();

				// bV𐶐
				TriangleMesh mesh = new TriangleMesh();

				mesh.getPoints().addAll(POINTS_SKY2);
				mesh.getTexCoords().addAll(TEXCOORDS);
				mesh.getFaces().addAll(FACES);

				// }eA𐶐
				PhongMaterial material = new PhongMaterial();
				material.setDiffuseMap(images[1]);

				// bVo^
				meshView.setMesh(mesh);
				meshView.setMaterial(material);

				// ʒuC
				meshView.setTranslateX(i * 200);
				meshView.setTranslateZ(299.9999); 

				// bVr[ǉ
				this.getChildren().add(meshView);

				// Qm[hꗗɐݒ
				meshViewSky2s[i] = meshView;

			} // end for QA[v

		// Xe[WQ̏ꍇA
		}else if(stage == 2){

			// ̐FJ[LF
			material.setDiffuseColor(Color.KHAKI);

			// Pm[hꗗ𐶐
			meshViewSky1s = new MeshView[2];

			// QA[v
			for(int i = 0; i < 2; i++){

				// bVr[𐶐
				MeshView meshView = new MeshView();

				// bV𐶐
				TriangleMesh mesh = new TriangleMesh();

				mesh.getPoints().addAll(POINTS_SKY1);
				mesh.getTexCoords().addAll(TEXCOORDS);
				mesh.getFaces().addAll(FACES);

				// }eA𐶐
				PhongMaterial material = new PhongMaterial();
				material.setDiffuseMap(images[2]);

				// bVo^
				meshView.setMesh(mesh);
				meshView.setMaterial(material);

				// ʒuC
				meshView.setTranslateX(i * 200);
				meshView.setTranslateZ(299.9999); 

				// bVr[ǉ
				this.getChildren().add(meshView);

				// Pm[hꗗɐݒ
				meshViewSky1s[i] = meshView;

			} // end for PA[v

			// Qm[hꗗ𐶐
			meshViewSky2s = new MeshView[2];

			// QA[v
			for(int i = 0; i < 2; i++){

				// bVr[𐶐
				MeshView meshView = new MeshView();

				// bV𐶐
				TriangleMesh mesh = new TriangleMesh();

				mesh.getPoints().addAll(POINTS_SKY2);
				mesh.getTexCoords().addAll(TEXCOORDS);
				mesh.getFaces().addAll(FACES);

				// }eA𐶐
				PhongMaterial material = new PhongMaterial();
				material.setDiffuseMap(images[3]);

				// bVo^
				meshView.setMesh(mesh);
				meshView.setMaterial(material);

				// ʒuC
				meshView.setTranslateX(i * 200);
				meshView.setTranslateZ(299.9999); 

				// bVr[ǉ
				this.getChildren().add(meshView);

				// Qm[hꗗɐݒ
				meshViewSky2s[i] = meshView;

			} // end for QA[v

		// Xe[WȐꍇA
		}else if(stage == 3){

			// ̐FR[t[Eu[F
			material.setDiffuseColor(Color.CORNFLOWERBLUE);

		// Xe[WS̏ꍇA
		}else if(stage == 4){

			// ̐FhW[Eu[F
			material.setDiffuseColor(Color.DODGERBLUE);

		// Xe[WT̏ꍇA
		}else if(stage == 5){

			// ̐FF
			material.setDiffuseColor(Color.BLACK);

		} // end if Xe[W

	} // end setStage

	/**
	 * Xړ
	 * @param mx Xړ
	 */
	public void moveX(double mx){

		// ʖ߂
		int ctrlModosi = 0;

		// Pm[hꗗ̌擾
		int countMeshViewsSky1 = meshViewSky1s.length;

		// Pm[hꗗ̌A[v
		for(int i = 0; i < countMeshViewsSky1; i++){

			// Pm[h擾
			MeshView meshView = meshViewSky1s[i];

			// W擾
			double x = meshView.getTranslateX();

			// WZ
			x = x + mx / 4;

			// Oڂ̏ꍇA
			if(i == 0){

				// X-200𒴂ꍇA
				if(x < -200){
					// Eɖ߂
					ctrlModosi = 1;

				// X0𒴂ꍇA
				}else if(x > 0){
					// ʖ߂tOON
					ctrlModosi = 2;
				}

			} // end for Oڂ̏ꍇ

			// Eɖ߂ꍇA
			if(ctrlModosi == 1){

				// Eɖ߂
				x = x + 200;

			// ɖ߂ꍇA
			}else if(ctrlModosi == 2){

				// ɖ߂
				x = x - 200;

			}

			// ړ
			meshView.setTranslateX(x);

		} // end for Pm[hꗗ̌A[v

		// Qm[hꗗ̌擾
		int countMeshViewsSky2 = meshViewSky2s.length;

		// Qm[hꗗ̌A[v
		for(int i = 0; i < countMeshViewsSky2; i++){

			// Qm[h擾
			MeshView meshView = meshViewSky2s[i];

			// W擾
			double x = meshView.getTranslateX();

			// WZ
			x = x + mx;

			// Oڂ̏ꍇA
			if(i == 0){

				// X-200𒴂ꍇA
				if(x < -200){
					// Eɖ߂
					ctrlModosi = 1;

				// X0𒴂ꍇA
				}else if(x > 0){
					// ʖ߂tOON
					ctrlModosi = 2;
				}

			} // end for Oڂ̏ꍇ

			// Eɖ߂ꍇA
			if(ctrlModosi == 1){

				// Eɖ߂
				x = x + 200;

			// ɖ߂ꍇA
			}else if(ctrlModosi == 2){

				// ɖ߂
				x = x - 200;

			}

			// ړ
			meshView.setTranslateX(x);

		} // end for Qm[hꗗ̌A[v

	} // end moveX

	/**
	 * s
	 */
	@Override
	public void run(){

	} // end run

}
